VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Form1"
   ClientHeight    =   3900
   ClientLeft      =   2835
   ClientTop       =   1230
   ClientWidth     =   6015
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   260
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   401
   Begin VB.Label lblIntersects 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   5775
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Click and drag to create two lines."
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5775
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_X(0 To 3) As Single
Private m_Y(0 To 3) As Single
Private m_NextPoint As Integer
' Return True if the segments intersect.
Private Function SegmentsIntersect(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, ByVal A1 As Single, ByVal B1 As Single, ByVal A2 As Single, ByVal B2 As Single) As Boolean
Dim dx As Single
Dim dy As Single
Dim da As Single
Dim db As Single
Dim t As Single
Dim s As Single

    dx = X2 - X1
    dy = Y2 - Y1
    da = A2 - A1
    db = B2 - B1
    If (da * dy - db * dx) = 0 Then
        ' The segments are parallel.
        SegmentsIntersect = False
        Exit Function
    End If
    
    s = (dx * (B1 - Y1) + dy * (X1 - A1)) / (da * dy - db * dx)
    t = (da * (Y1 - B1) + db * (A1 - X1)) / (db * dx - da * dy)
    SegmentsIntersect = (s >= 0# And s <= 1# And _
                         t >= 0# And t <= 1#)
    
    ' If it exists, the point of intersection is:
    ' (x1 + t * dx, y1 + t * dy)
End Function

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If m_NextPoint = 4 Then
        Me.Cls
        m_NextPoint = 0
    End If

    m_X(m_NextPoint) = X
    m_Y(m_NextPoint) = Y

    Me.Circle (X, Y), 3

    m_NextPoint = m_NextPoint + 1
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_X(m_NextPoint) = X
    m_Y(m_NextPoint) = Y

    Me.Circle (X, Y), 3

    If m_NextPoint = 1 Then
        Me.Line (m_X(0), m_Y(0))-(m_X(1), m_Y(1))
    ElseIf m_NextPoint = 3 Then
        Me.Line (m_X(2), m_Y(2))-(m_X(3), m_Y(3))
        If SegmentsIntersect(m_X(0), m_Y(0), m_X(1), m_Y(1), m_X(2), m_Y(2), m_X(3), m_Y(3)) Then
            lblIntersects.Caption = "Intersect"
        Else
            lblIntersects.Caption = "Do not intersect"
        End If
    End If

    m_NextPoint = m_NextPoint + 1
End Sub
